#include <stdio.h>
#include <avs/flow.h>
#include <avs/avs_data.h>
#include <avs/field.h>

extern float bscall();
extern float implied_vol();

fin()
{
	int out_port;		/* temporary to hold the port number */
	int parm;		/* temporary to hold the parm number */

	/* Set the module name and type */
	AVSset_module_name("test", MODULE_DATA);

	/* There are no input ports for this module */

	/* Create output ports for the result */
	out_port = AVScreate_output_port("Field Output", "field 1D scalar uniform float");

	/* Add parameter:  */
	parm = AVSadd_parameter("points/frame","integer", 30, 1, 100);
	AVSconnect_widget(parm,"idial");
	parm = AVSadd_parameter("sleep", "boolean", 1, 0, 1);

	/* There is no compute function for this module */
}

#define PERFRAME 30

main(argc,argv)
int	argc;
char	*argv[];
{
   int fin();
   int sleep,step;
   AVSfield_float *output, *input;
   
   int dims[1];
   int i, size = PERFRAME;
   float *tmp,temp;
   float j;
   float xran();

  
   FILE *sfp, *pfp;
   int flag;
   float sz,szdiv,k,rate,t,tdiv,div,call, vt_a, vt_b;
   long int total;


   /* coroutine initilization */
   AVScorout_init(argc,argv,fin);
   AVScorout_set_sync(0); 

   while (1) {
     sleep = step = 1;
     input = NULL;
     do {
       AVScorout_wait();  
       AVScorout_input(&size,&sleep);
     } while (sleep !=0);

     /* Allocate space for graph data */
     dims[0] = size;
     input = (AVSfield_float *)AVSdata_alloc("field 1D scalar uniform float",dims);
     
     j = 1.0;
     /* first output an initial graph */

     while (1) {
       
       if (sleep) AVScorout_wait();
       
       AVScorout_input(&size,&sleep);
       for (i=0; i<(size-1); i++) {
	 input->data[i] = input->data[i+1] ;  /* 1st vector element */
       };
       temp = xran(5.0);
       input->data[size-1] = temp;
       printf("j = %f temp = %f\n",++j,temp);

       output = input;
       AVScorout_exec();
       AVScorout_output(output);  

     }
     AVSfield_free(input);

     /* initilize parameter  */
   }
 }

float xran(n)
     float n;
{   
  double drand48();
  return(n*drand48());
}

